// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/**
 This object represents a Telegram user or bot.

 SeeAlso Telegram Bot API Reference:
 [User](https://core.telegram.org/bots/api#user)
 */
public final class User: Codable {

    /// Custom keys for coding/decoding `User` struct
    enum CodingKeys: String, CodingKey {
        case id = "id"
        case isBot = "is_bot"
        case firstName = "first_name"
        case lastName = "last_name"
        case username = "username"
        case languageCode = "language_code"
    }

    /// Unique identifier for this user or bot
    public var id: Int64

    /// True, if this user is a bot
    public var isBot: Bool

    /// User‘s or bot’s first name
    public var firstName: String

    /// Optional. User‘s or bot’s last name
    public var lastName: String?

    /// Optional. User‘s or bot’s username
    public var username: String?

    /// Optional. IETF language tag of the user's language
    public var languageCode: String?


    public init (id: Int64, isBot: Bool, firstName: String, lastName: String? = nil, username: String? = nil, languageCode: String? = nil) {
        self.id = id
        self.isBot = isBot
        self.firstName = firstName
        self.lastName = lastName
        self.username = username
        self.languageCode = languageCode
    }
}
